package cz.upol.jj2.lab03;

/**
 * Banka, ktera pouziva synchronized metody.
 * Metoda je synchornized v ramci dane instance.
 * Tj. max jedno vlakno muze v danem case vykonavat nejakou synchronized metodu.
 * V podstate jde o monitor prislusny dane instanci.
 *
 * Existuji i static synchronized metody.
 * Takova muze v danem okamziku bezet jen jedna v ramci celeho programu (monitor class objektu tridy)
 */
public class Bank2 implements Bank
{
	private String name;
	private int[] account;

	public Bank2(String name, int count) {
		this.name = name;
		this.account = new int[count];
	}

	public synchronized void transfer(int from, int to, int amount) {
		account[from] -= amount;
		account[to] += amount;
		System.out.println(String.format("%s banka: $%d prevedeno z uctu %d na ucet %d", name, amount, from, to));
	}

	public synchronized int summary() {
		int sum = 0;
		for (Integer a: account)
			sum += a;
		return sum;
	}

	public String getName() {
		return name;
	}

}
