package cz.upol.jj2.lab03;

/**
 * Uplne zaklady pouziti virtualnich vlaken od Java 21.
 * Je to jen jiny typ vlakna, tj. lze s nim delat stejne veci jako s klasickym platformovym (OS) vlaknem.
 * Nize ukazky vytvareni.
 * Vice informaci na seminari.
 */
public class VirtualThreads {

    public static void main(String[] args) {
        Runnable work =() -> {System.out.println("Pracuji");};

        // virtualni vlakno
        Thread.ofVirtual().start(work);
        // platformove vlakno
        Thread.ofPlatform().start(work);

        // builder vlaken
        Thread.Builder builder = Thread.ofVirtual().name("VirtualThreads");
        try {
            for (var i = 0; i < 10; i++) {
                System.out.print("Vlakno " + i + " ");
                Thread t = builder.start(work);  //spusteni vlakna z daneho builderu (a predani prace)
                t.join();  //zkuste zakomentovat ...
            }
        } catch (Exception e){
            System.out.println("Ale toto je neprijemne.");
        }
    }
}
